package com.jaxfront.demo;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.net.URL;

import javax.swing.SwingUtilities;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.log.LogRegistry;
import com.jaxfront.core.util.JAXFrontProperties;
import com.jaxfront.swing.ui.editor.EditorPanel;

/**
 * Demonstrates the use of JAXFront UI's within a demo applet.
 */
/*-- 

 Copyright (C) 2001-2012 by xcentric technology & consulting GmbH. All rights reserved.

 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 */
public class DemoApplet extends Applet {
	public void init() {
		String xsd = getParameter("xsd");
		String xml = getParameter("xml");
		String xui = getParameter("xui");
		String language = getParameter("language");
		if (language == null) language = "en";
		String root = getParameter("root");
		URL codeBase = getCodeBase();
		JAXFrontProperties.getInstance().setURLBase(codeBase.toExternalForm());
		// Document.setLanguage(language);
		String userId = "You are using Java Version (" + System.getProperty("java.version") + ") under OS (" + System.getProperty("os.arch") + "/" + System.getProperty("os.name") + ").";
		JAXFrontProperties.getInstance().setUserProperty("" + "USER_ID", userId);
		try {
			URL xsdURL = new URL(codeBase, xsd);
			URL xmlURL = null;
			URL xuiURL = null;
			if (xsdURL != null) LogRegistry.getInstance().log(getClass(), "XSD: " + xsdURL.toExternalForm());
			if (xml != null) LogRegistry.getInstance().log(getClass(), "XML: " + xml);
			if (xui != null) LogRegistry.getInstance().log(getClass(), "XUI: " + xui);
			if (xml != null) xmlURL = new URL(codeBase, xml);
			if (xui != null) xuiURL = new URL(codeBase, xui);
			if (xsdURL != null) LogRegistry.getInstance().log(getClass(), "XSD: " + xsdURL.toExternalForm());
			if (xmlURL != null) LogRegistry.getInstance().log(getClass(), "XML: " + xmlURL.toExternalForm());
			if (xuiURL != null) LogRegistry.getInstance().log(getClass(), "XUI: " + xuiURL.toExternalForm());
			Document dom = DOMBuilder.getInstance().build(null, xsdURL, xmlURL, xuiURL, root);
			Frame parentFrame = (Frame) SwingUtilities.getAncestorOfClass(Frame.class, this);
			EditorPanel editorPanel = new EditorPanel(dom.getRootType(), parentFrame);
			this.setLayout(new BorderLayout());
			this.add(editorPanel, BorderLayout.CENTER);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void start() {}

	public void stop() {}

	public void destroy() {}
}
