package com.jaxfront.demo;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.dom.DocumentCreationException;
import com.jaxfront.core.schema.SchemaCreationException;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.swing.ui.editor.EditorPanel;

/**
 * Demonstrates the use of JAXFront UI's within an internal JFrame.
 */
/*-- 

 Copyright (C) 2001-2012 by xcentric technology & consulting GmbH. All rights reserved.

 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 */
public class JIFrameDemo {
	/* Main View */
	public static void main(String[] a) {
		String lnfName = "com.jgoodies.looks.plastic.PlasticXPLookAndFeel";
		try {
			UIManager.setLookAndFeel(lnfName);
		} catch (UnsupportedLookAndFeelException ex1) {
			System.err.println("Unsupported LookAndFeel: " + lnfName);
		} catch (ClassNotFoundException ex2) {
			System.err.println("LookAndFeel class not found: " + lnfName);
		} catch (InstantiationException ex3) {
			System.err.println("Could not load LookAndFeel: " + lnfName);
		} catch (IllegalAccessException ex4) {
			System.err.println("Cannot use LookAndFeel: " + lnfName);
		}
		final JFrame jf = new JFrame("JIFrameDemo Main Window");
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		screenSize.width -= 300;
		screenSize.height -= 300;
		jf.setSize(screenSize);
		jf.setLocation(20, 20);
		JMenuBar mb = new JMenuBar();
		jf.setJMenuBar(mb);
		JMenu fm = new JMenu("File");
		mb.add(fm);
		JMenuItem mi;
		fm.add(mi = new JMenuItem("Exit"));
		mi.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		JDesktopPane dtp = new JDesktopPane();
		jf.setContentPane(dtp);
		JInternalFrame mboxFrame = new JInternalFrame("JAXFront Demo (EditorPanel)", true, true, true, true);
		Document dom = null;
		try {
			dom = DOMBuilder.getInstance().build("default-context", URLHelper.getUserURL("examples/purchaseOrder/po.xsd"), URLHelper.getUserURL("examples/purchaseOrder/po.xml"), URLHelper.getUserURL("examples/purchaseOrder/po.xui"), null);
			EditorPanel editorPanel = new EditorPanel(dom.getRootType(), null);
			mboxFrame.setContentPane(editorPanel);
			mboxFrame.setSize(650, 400);
			mboxFrame.setLocation(10, 10);
			mboxFrame.setVisible(true);
			dtp.add(mboxFrame);
		} catch (SchemaCreationException e1) {
			e1.printStackTrace();
		} catch (DocumentCreationException e1) {
			e1.printStackTrace();
		}
		jf.setVisible(true);
		jf.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				jf.setVisible(false);
				jf.dispose();
				System.exit(0);
			}
		});
	}
}