package com.jaxfront.demo.api;

import com.jaxfront.core.rule.Condition;
import com.jaxfront.core.rule.FormulaException;
import com.jaxfront.core.type.SimpleType;
import com.jaxfront.core.type.Type;

/**
 * Demonstrates how to implement an own condition. This condition checks if the underlying date is a future date.
 */
/*-- 

 Copyright (C) 2001 by xcentric technology & consulting GmbH.
 All rights reserved.

 This software is the confidential and proprietary information
 of xcentric technology & consulting GmbH ("Confidential Information"). 
 You shall not disclose such Confidential Information and shall use
 it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 com.jaxfront.demo.api.Exercise5Condition
 */
public class Exercise5Condition extends Object implements Condition {
	Type _sourceType;

	public boolean isTrue(Type source) throws FormulaException {
		SimpleType simpleType = (SimpleType) _sourceType;
		String aValue = simpleType.getValue();
		System.out.println(this.getClass().getSimpleName() + "-> value:" + aValue + " has to be Exercise to  become true");
		if (aValue != null && aValue.equalsIgnoreCase("Exercise")) {
			return true;
		}
		return false;
	}

	public boolean doesConcern(Type checkType) {
		return checkType == _sourceType;
	}

	public void setSourceType(Type sourceType) {
		_sourceType = sourceType;
	}
}
