package com.jaxfront.demo.api;

import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.type.NULL;

import com.jaxfront.core.jep.SuperTypeNode;
import com.jaxfront.core.rule.MathEvaluator.MathCommunicator;
import com.jaxfront.core.type.SimpleType;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.type.TypePathExecuter;

public class Exercise7Function extends SuperTypeNode {
	/**
	 * @see org.nfunk.jep.function.PostfixMathCommandI#run(Stack)
	 */
	public void run(MathCommunicator comm, Stack stack) throws ParseException {
		// Check if stack is null
		checkStack(stack);
		Object param = null;
		String xPath = null;
		Type resultType = null;
		if (curNumberOfParameters == 0) {
			resultType = comm.getRootType();
		} else if (curNumberOfParameters == 1) {
			Type baseType = comm.getRootType();
			param = stack.pop();
			if (param == NULL._null) {
				stack.push(NULL._null);
				return;
			} else if (param instanceof Type) {
				baseType = (Type) param;
			} else if (param instanceof String) {
				xPath = (String) param;
			}
			if (xPath != null && xPath.length() > 0) {
				resultType = TypePathExecuter.getInstance().getTypeForXPath(baseType, xPath.trim(), true, true);
			} else {
				resultType = baseType;
			}
		} else {
			throw new ParseException(this.getClass() + " Invalid parameter type");
		}
		if (resultType != null) {
			if (resultType.isSimple()) {
				SimpleType simpleType = (SimpleType) resultType;
				String value = simpleType.getValue();
				if (value != null) {
					if (value.equals("Exercise")) {
						stack.push(SuperTypeNode.isTrue);
						return;
					}
				}
			} else {
				throw new ParseException(this.getClass() + " Invalid target type (must be simple)");
			}
		}
		stack.push(SuperTypeNode.isFalse);
	}
}
