package com.jaxfront.demo.api;

import com.jaxfront.core.rule.Action;
import com.jaxfront.core.type.ListType;
import com.jaxfront.core.type.SimpleType;
import com.jaxfront.core.type.Type;
/**
 * Demonstrates how to implement your own action to add 
 * nodes dynamically through the API.
 */
/*-- 

Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

This software is the confidential and proprietary information of xcentric technology & 
consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
Information and shall use it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class OwnActionAddingNodes implements Action {

	public void perform(Type eventSource, Type target) {
		
		if (target.isList()) {
			ListType listType = (ListType)target;
			
			Type listEntry = listType.addNewChild();
			listEntry.setDirectChildValue("E", "new value (" + ((SimpleType)eventSource).getValue() + ")");
			listEntry.setDirectChildValue("F", "new value (" + ((SimpleType)eventSource).getValue() + ")");
		}
	}
	
}
