package com.jaxfront.demo.api;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.net.URL;

import com.jaxfront.core.log.LogRegistry;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.core.util.io.FileHelper;
import com.jaxfront.core.xui.CodeSet;
/**
 * Demonstrates how to implement your own codeSet resolver. 
 * For demo purposes, this will open the content of a local
 * codeset file (po.codes).
 * 
 * The Reader returning has to be an xml content reader following 
 * the codes.xsd (see jaxfront-core.jar).
 */
/*-- 

Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

This software is the confidential and proprietary information of xcentric technology & 
consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
Information and shall use it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class OwnCodeSetResolverImpl implements CodeSet {

	public Reader getCodeSet(Type type, String codeSetName, String versionNo) {

		//for demo purposes, load the codeset file from local jar/file system
		String fileName = "examples/purchaseOrder/po.codes";
		URL codeSetURL = URLHelper.getUserURL(fileName);
		try {
			if (codeSetURL != null) {
				String xmlContent = FileHelper.readFileAsString(codeSetURL);
				return new StringReader(xmlContent);
			}
		}
		catch (IOException ex) {
			LogRegistry.getInstance().warn(getClass(), "Unable to open file: " + fileName);
		}
		return null;
	}
}
