package com.jaxfront.demo;

import java.awt.BorderLayout;
import java.awt.Window;
import java.net.URL;

import javax.swing.JFrame;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.dom.DocumentCreationException;
import com.jaxfront.core.schema.SchemaCreationException;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.swing.ui.editor.EditorPanel;

public class BuildGUIFromXML {
	public static void main(String[] args) {
		URL poXMLURL = URLHelper.getUserURL("examples/purchaseOrder/po-noXSD.xml");
		Document dom;
		try {
			dom = DOMBuilder.getInstance().buildImplicit(poXMLURL);
			Window myFrame = new JFrame("Build GUI from XML (purchaseOrder.xml)");
			myFrame.setSize(800, 600);
			EditorPanel editor = new EditorPanel(dom.getRootType(), myFrame);
			myFrame.setLayout(new BorderLayout());
			myFrame.add(editor, BorderLayout.CENTER);
			myFrame.setVisible(true);
		} catch (SchemaCreationException e) {
			e.printStackTrace();
		} catch (DocumentCreationException e) {
			e.printStackTrace();
		}
	}
}
