package com.jaxfront.demo;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.jaxfront.core.util.JAXFrontProperties;
import com.jaxfront.swing.ui.layout.ListLayout;
import com.jaxfront.swing.ui.tools.FontTools;

/*****************************************************************************************************************************************************
 * Zeigt den Texts des Beispiels sowie ein Beispielbild an.
 * 
 * @version 1.60
 ****************************************************************************************************************************************************/
/*-- 

 Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 */
public class ExampleHeader extends JPanel implements ActionListener {
	private JButton _openXSD;
	private String _xsdURL;
	private TestFrame _testFrame;

	public ExampleHeader(TestFrame testFrame, String title, ImageIcon image, String xsdURL) {
		super();
		_testFrame = testFrame;
		_xsdURL = xsdURL;
		init(title, image);
	}

	private void init(String title, ImageIcon image) {
		setLayout(new BorderLayout());
		if (title == null) {
			title = "JAXFront Demo Example";
			_openXSD = new JButton(JAXFrontProperties.getImageIcon("examples/demo-suite/images/jaxfront.gif"));
		} else
			_openXSD = new JButton(image);
		_openXSD.addActionListener(this);
		add(_openXSD, BorderLayout.EAST);
		JPanel infoPanel = new JPanel(new ListLayout(2));
		JLabel infoText = new JLabel(title);
		infoText.setFont(FontTools.getBoldFont(20));
		infoPanel.add(infoText);
		// JLabel subText = new JLabel("(Click on image on the right to render again.)");
		// subText.setFont(FontTools.getBoldFont(12));
		// infoPanel.add(subText);
		add(infoPanel, BorderLayout.CENTER);
	}

	public void actionPerformed(ActionEvent e) {
		_testFrame.myExample();
	}
}
