package com.jaxfront.demo;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.UIManager;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.dom.DocumentCreationException;
import com.jaxfront.core.schema.SchemaCreationException;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.swing.ui.layout.ListLayout;

/************************************************************************************
 * JAXFront Integration and use of the TypeVisualizerFactory Demo Implementation.
 * 
 * @version 1.60
 ************************************************************************************/
/*-- 

 Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 */
public class OwnContainer extends javax.swing.JFrame {
	private OwnContainer() {
		super();
		initialize();
	}

	private void initialize() {
		Document dom = null;
		java.net.URL url = null;
		java.net.URL xuiUrl = null;
		java.net.URL xmlUrl = null;
		try {
			url = URLHelper.getUserURL("examples/purchaseOrder/po.xsd");
			xuiUrl = URLHelper.getUserURL("examples/purchaseOrder/po.xui");
			xmlUrl = URLHelper.getUserURL("examples/purchaseOrder/po.xml");
			dom = DOMBuilder.getInstance().build(null, url, xmlUrl, xuiUrl, "purchaseOrder");
			com.jaxfront.core.type.Type rootType = dom.getRootType();
			getContentPane().setLayout(new BorderLayout());
			JPanel myContainer = new JPanel();
			myContainer.setLayout(new ListLayout(10));
			JComponent shipToComponent = (JComponent) TypeVisualizerFactory.getInstance().getVisualizer(rootType.getDirectChild("shipTo"));
			JComponent billToComponent = (JComponent) TypeVisualizerFactory.getInstance().getVisualizer(rootType.getDirectChild("billTo"));
			JComponent leafComponent = (JComponent) TypeVisualizerFactory.getInstance().getVisualizer(rootType.getDirectChild("comment"));
			myContainer.add(shipToComponent);
			myContainer.add(billToComponent);
			myContainer.add(leafComponent);
			getContentPane().add(myContainer, java.awt.BorderLayout.CENTER);
			setTitle("JAXFront HelloWorld - OwnContainer");
			setSize(500, 500);
		} catch (SchemaCreationException ex) {
			System.out.println("unable to create XML Schema from" + url);
		} catch (DocumentCreationException domEx) {
			System.out.println("unable to create JAXFront DOM from" + url);
		}
	}

	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel("com.jgoodies.plaf.plastic.PlasticXPLookAndFeel");
		} catch (Throwable t) {}
		OwnContainer ownContainer = new OwnContainer();
		ownContainer.setVisible(true);
	}
}
