package com.jaxfront.demo.api;

import java.awt.Color;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JComponent;

import com.jaxfront.core.dom.Document;
import com.jaxfront.core.rule.Action;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.core.ui.Visualizer;
import com.jaxfront.core.xui.XUITypes;
import com.jaxfront.swing.ui.visualizers.AbstractView;
/*-- 

Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

This software is the confidential and proprietary information of xcentric technology & 
consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
Information and shall use it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class ChangeState extends AbstractAction {

	private boolean _visible = true;
	private boolean _collapse = false;
	private boolean _treeNode = false;
	
	public void actionPerformed(ActionEvent event) {
		Document dom = (Document)getValue(Action.ACTION_DOM);
		Type source = (Type)getValue(Action.ACTION_SOURCE);

		String actionName = event.getActionCommand();
		Type target = source.getParent().getDirectChild("list");
		Visualizer targetVisualizer = TypeVisualizerFactory.getInstance().getVisualizer(target);
		if (actionName.equals("visibility")) {
			_visible = !_visible;
			targetVisualizer.setVisible(_visible);
		}
		else if (actionName.equals("collapse")) {
			_collapse = !_collapse;
			if (_collapse) ((AbstractView)targetVisualizer.getImplementation()).getBorderPanel().collapseInitially();
			else ((AbstractView)targetVisualizer.getImplementation()).getBorderPanel().expandInitially();
		}
		else if (actionName.equals("treeNode")) {
			_treeNode = !_treeNode;

			if (_treeNode) ((AbstractView)targetVisualizer.getImplementation()).addTreeNode(true);
			else ((AbstractView)targetVisualizer.getImplementation()).removeTreeNode(true);
		}
	}
}
