package com.jaxfront.demo.api;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import com.jaxfront.core.dom.DOMChangeEvent;
import com.jaxfront.core.dom.DOMChangeListener;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.swing.ui.visualizers.AbstractCompositeView;
/**
 * Demonstrates how to use the JAXFront Event-Handling (propertyChange &
 * domChange).
 */

/*-- 

Copyright (C) 2001 by xcentric technology & consulting GmbH.
All rights reserved.

This software is the confidential and proprietary information
of xcentric technology & consulting GmbH ("Confidential Information"). 
You shall not disclose such Confidential Information and shall use
it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class EventHandling extends AbstractCompositeView implements PropertyChangeListener, DOMChangeListener{
	
	private JTextArea _textArea;

	protected void defaultBuild() {
		setLayout(new BorderLayout());
		JComponent visualizer = (JComponent)TypeVisualizerFactory.getInstance().getVisualizer(getModel().getDirectChild("simpleGroup"));
		add(visualizer, BorderLayout.NORTH);
		visualizer = (JComponent)TypeVisualizerFactory.getInstance().getVisualizer(getModel().getDirectChild("list"));
		add(visualizer, BorderLayout.CENTER);
		
		_textArea = new JTextArea();
		JScrollPane scrollPane = new JScrollPane(_textArea);
		scrollPane.setPreferredSize(new Dimension(300, 300));
		add(scrollPane, BorderLayout.SOUTH);

		getModel().getDOM().getController().addPropertyChangeListener(this);
		getModel().getDOM().addDOMChangeListener(this);
	}
	public void propertyChange(PropertyChangeEvent event) {
		super.propertyChange(event);
		_textArea.setText(event.toString());
	}
	public void domChanged(DOMChangeEvent event) {
		super.domChanged(event);
		
		_textArea.setText(event.toString());
	}
	public void setApplicationRequired(boolean aBoolean) {}
	public void setRequired(boolean aBoolean) {}
}
