package com.jaxfront.demo.api;

import com.jaxfront.core.type.Type;
import com.jaxfront.html.visualizers.SimpleTypeView;
import com.jaxfront.objectivehtml.htmlwidget.HtmlContainerWidget;
import com.jaxfront.objectivehtml.htmlwidget.HtmlPlainTextWidget;

/*-- 

 Copyright (C) 2001-2008 by xcentric technology & consulting GmbH. All rights reserved.

 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com

 */
/**
 * Shows how to implement your own plugin for a simple component (leaf) using plain HTML.
 * 
 */
public class Exercise8HTMLPlugin extends SimpleTypeView {
	protected void createEditorComponent(HtmlContainerWidget container) {
		_component = new HtmlPlainTextWidget(container, getHTMLContent().toString());
	}

	public Exercise8HTMLPlugin(Type type, Type context) {
		setContext(context);
		setModel(type);
	}

	public void populateView() {
		super.populateView();
		((HtmlPlainTextWidget) _component).setHTMLContent(getHTMLContent().toString());
	}

	public StringBuffer getHTMLContent() {
		StringBuffer sb = new StringBuffer();
		sb.append("<b>Choose your favorite street!</b><br/><br/>");
		sb.append("<select id=\"" + getXPath() + "\" size=\"3\" onclick=\"saveData(this)\">");
		String[] names = new String[] { "Nowhere Land", "Palm Street", "Example Street", "Wall Street", "Bahnhof Street" };
		String selected = "";
		for (int i = 0; i < names.length; i++) {
			if (getValue() != null && getValue().equals(names[i])) selected = "selected";
			else
				selected = "";
			sb.append("<option " + selected + " value=\"" + names[i] + "\">" + names[i] + "</option>");
		}
		sb.append("</select>");
		return sb;
	}

	public void setSize(String size) {
		// do nothing
	}
}
