package com.jaxfront.demo.api;

import java.awt.BorderLayout;
import java.net.URL;
import javax.swing.JFrame;
import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.util.JAXFrontProperties;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.core.util.io.FileHelper;
import com.jaxfront.swing.ui.editor.EditorPanel;
import com.jaxfront.xuieditor.JAXFrontPreferencesDialog;

public class LoadXUIFromStringExample {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		URL xsdURL = URLHelper.getUserURL("c:\\temp\\purchaseOrder\\po.xsd");
		URL xuiURL = URLHelper.getUserURL("c:\\temp\\purchaseOrder\\po.xui");
		JAXFrontProperties.getInstance().setUseEmbeddedNLS(true);
		String xsdString;
		try {
			xsdString = FileHelper.readFileAsString(xsdURL);
			String xuiString = FileHelper.readFileAsString(xuiURL);
			
			Document dom = DOMBuilder.getInstance().build(xuiURL, xsdString, null, xuiString, null, null);
			
			JFrame frame = new JFrame("Title");
			frame.getContentPane().setLayout(new BorderLayout());
			frame.getContentPane().add(new EditorPanel(dom.getRootType(), frame));
			
			frame.setSize(800,600);
			frame.show();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
		
		
	}
}
