package com.jaxfront.demo.api;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.type.NULL;

import com.jaxfront.core.jep.SuperTypeNode;
import com.jaxfront.core.rule.MathEvaluator.MathCommunicator;
import com.jaxfront.core.type.SimpleType;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.type.TypePathExecuter;

public class OwnFunction extends SuperTypeNode {

	/**
	 * @see org.nfunk.jep.function.PostfixMathCommandI#run(Stack)
	 */
	public void run(MathCommunicator comm,Stack stack) throws ParseException {
		// Check if stack is null
		checkStack(stack);
		Object param = null;
		String xPath = null;
		boolean isFutureDate = false;
		
		if (curNumberOfParameters == 1) {
			Type baseType = comm.getRootType();

			param = stack.pop();
			if (param == NULL._null) {
				stack.push(NULL._null);
				return;
			} else if (param instanceof Type) {
				baseType = (Type) param;
			} else if (param instanceof String) {
				xPath = (String) param;
			} 

			Type resultType = null;
			if (xPath != null && xPath.length() > 0) {
				resultType =
					TypePathExecuter.getInstance().getTypeForXPath(
						baseType,
						xPath.trim(),
						true,
						true);
			} else
				resultType = baseType;
			
			if (resultType != null) {
				if (resultType.isSimple()) {
					SimpleType simpleType = (SimpleType)resultType;
					String dateString = simpleType.getValue();
					
					if (dateString != null) {
						try {
							SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
							Date inputDate = format.parse(dateString);
							Date currentDate = new Date();
							
							isFutureDate = inputDate.compareTo(currentDate) > 0;
						}
						catch (java.text.ParseException ex) {
							//do nothing
						}
					}
				} else {
					throw new ParseException(this.getClass() + " Invalid target type (must be simple)");
				}
			}
			if (isFutureDate) {
				stack.push(SuperTypeNode.isTrue);
			}
			else {
				stack.push(SuperTypeNode.isFalse);
			}
			
		} else {
			throw new ParseException(this.getClass() + " Invalid parameter type");
		}
	}
}
