package com.jaxfront.demo.api;

import java.awt.Color;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BorderFactory;

import com.jaxfront.core.rule.Action;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.core.ui.Visualizer;
import com.jaxfront.swing.ui.visualizers.AbstractSimpleTypeView;
/**
 * Demonstrates how to implement your own action. This action will unmark
 * the target type visualizer with a green border and set a normal line border.
 */
/*-- 

Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.

This software is the confidential and proprietary information of xcentric technology & 
consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
Information and shall use it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class OwnInverseAction implements Action {
    
	public void perform(Type sourceType,Type target) {
		Vector visualizers = TypeVisualizerFactory.getInstance().getAllVisualizers(target);
		Iterator iterator = visualizers.iterator();
		while (iterator.hasNext()) {
	    	AbstractSimpleTypeView component = (AbstractSimpleTypeView)((Visualizer)iterator.next()).getImplementation();
	    	component.getEditorField().setBorder(BorderFactory.createLineBorder(Color.black));
			
		}		
	}
}