package com.jaxfront.demo.api;

import java.awt.Color;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JTextArea;

import com.jaxfront.core.type.SimpleType;
import com.jaxfront.swing.ui.beans.AbstractSimpleVisualizer;
/**
 * This is a simple example of a plugIn (Java Bean) for JAXFront. This visualizer shows 
 * simply a label and a text area with 4 rows and a large font size. It should demonstrate 
 * how easily an own implementation of a simple visualizer can be realized.
 * 
 */
/*-- 

 Copyright (C) 2001-2003 by xcentric technology & consulting GmbH. All rights reserved.
 
 This software is the confidential and proprietary information of xcentric technology & 
 consulting GmbH ("Confidential Information"). You shall not disclose such Confidential 
 Information and shall use it only in accordance with the terms of the license agreement
 you entered into with xcentric.

 www.jaxfront.com
 
*/
public class OwnPlugin extends AbstractSimpleVisualizer {
	
	private JTextArea _textArea;

	public String getLabelText() {
		return "Simple Plugin Example";
	}
	public String getText() {
	    if (_textArea != null) return _textArea.getText();
	    return null;
	}

	public void populateView() {
		if (getModel() != null && _textArea != null) {
			String value = ((SimpleType)getModel()).getValue();
			if (value != null) {
				_textArea.setText(value);
			}
		}
	}

	protected JComponent createEditorComponent() {
		_textArea = new JTextArea();
		_textArea.setForeground(Color.blue);
		setBorder(BorderFactory.createMatteBorder(20,20,20,20,Color.GREEN));
		_textArea.addFocusListener(this);
		_textArea.setFont(new Font(null,1,20));
		_textArea.setRows(4);
		_textArea.setLineWrap(true);
		_textArea.addFocusListener(this);
		_firstFocusableComponent = _textArea;
		return _textArea;
	}
}