package com.jaxfront.demo.api;

import java.awt.BorderLayout;
import java.net.URL;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.dom.DocumentCreationException;
import com.jaxfront.core.log.LogRegistry;
import com.jaxfront.core.util.URLHelper;
import com.jaxfront.swing.ui.editor.EditorPanel;
import com.jaxfront.swing.ui.visualizers.AbstractCompositeView;

/**
 * Demonstrates how to use the JAXFront EditorPanel within your own
 * code.
 *
 */
/*-- 

Copyright (C) 2001 by xcentric technology & consulting GmbH.
All rights reserved.

This software is the confidential and proprietary information
of xcentric technology & consulting GmbH ("Confidential Information"). 
You shall not disclose such Confidential Information and shall use
it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class UseEditorPanel extends AbstractCompositeView {

	protected void defaultBuild() {
		setLayout(new BorderLayout());
		try {
	        URL xsdURL = URLHelper.getUserURL("examples/purchaseOrder/po.xsd");
	        URL xmlURL = URLHelper.getUserURL("examples/purchaseOrder/po.xml");
	        URL xuiURL = URLHelper.getUserURL("examples/purchaseOrder/po.xui");
			Document dom = DOMBuilder.getInstance().build(null, xsdURL, xmlURL, xuiURL, "purchaseOrder");
			EditorPanel editorPanel = new EditorPanel(dom.getRootType(), getEditor().getWindow());
			add(editorPanel, BorderLayout.CENTER);
		}
		catch (DocumentCreationException ex) {
			LogRegistry.getInstance().warn(getClass(), "Error while creating po.xsd DOM: " + ex.getLocalizedMessage());	
		}
	}

	public void setApplicationRequired(boolean aBoolean) {}

	public void setRequired(boolean aBoolean) {}
}
