package com.jaxfront.demo.api;

import java.awt.Color;
import java.util.Iterator;
import java.util.List;

import com.jaxfront.core.log.LogRegistry;
import com.jaxfront.core.rule.Action;
import com.jaxfront.core.type.ListModificationException;
import com.jaxfront.core.type.ListType;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.type.TypePathExecuter;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.swing.ui.visualizers.AbstractView;
/**
 * Demonstrates how to use the JAXFront XPath API
 */
/*-- 

Copyright (C) 2001 by xcentric technology & consulting GmbH.
All rights reserved.

This software is the confidential and proprietary information
of xcentric technology & consulting GmbH ("Confidential Information"). 
You shall not disclose such Confidential Information and shall use
it only in accordance with the terms of the license agreement
you entered into with xcentric.

www.jaxfront.com

*/
public class XPathAction implements Action {

	public void perform(Type aSource,Type source) {
		Type patternType = source.getChild("simpleGroup").getDirectChild("A");
		String pattern = source.getChild("simpleGroup").getDirectChildValue("A");
		String xpath = ".//A[.='" + pattern + "']";
		
		ListType listType = (ListType)source.getDirectChild("list");
		List found = TypePathExecuter.getInstance().processXPath(listType, xpath);
		
		AbstractView view = (AbstractView)TypeVisualizerFactory.getInstance().getVisualizer(patternType);
		String message = "Found (" + found.size() + " items) for XPath ("+ xpath + "). Going to delete them...";
		view.showHint(message, false, Color.RED, true);

		Iterator iterator = found.iterator();
		while (iterator.hasNext()) {
			try {
				listType.removeChild(((Type)iterator.next()).getParent());
			} catch (ListModificationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
