package com.jaxfront.demo.ui.beans;

import com.jaxfront.core.error.Error;
import com.jaxfront.core.error.UserError;
import com.jaxfront.core.rule.Action;
import com.jaxfront.core.type.SimpleType;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.xui.XUITypes;
/************************************************************************************
 * This class demonstrates the usage of filtered fields and throwing own error
 * messages. 
 * 
 * Look at the po.xsd, po.xml, po-html.xui example from the JAXFront examples.
 ************************************************************************************/
/*-- 
 Copyright (C) 2001-2003 by xcentric technology & consulting GmbH.
 All rights reserved.
 
 This software is the confidential and proprietary information
 of xcentric technology & consulting GmbH ("Confidential Information"). 
 You shall not disclose such Confidential Information and shall use
 it only in accordance with the terms of the license agreement
 you entered into with xcentric.
 
 www.jaxfront.com
*/
public class InsertZIPValuesAction implements Action {

	public void perform(Type source,Type target) {
		if (target.isSimple()) {
			SimpleType zipType = (SimpleType)target;
			SimpleType cityType = (SimpleType)target.getParent().getDirectChild("city");
			SimpleType countryType = (SimpleType)target.getParent().getDirectChild("country");
			String city = cityType.getValue();
			String[] zipCodes = new String[] {" "};
			String country = "";
			
			if (city.equals("Zurich")) {
				zipCodes = new String[] {"1", "2", "3"};
				country = "Switzerland";
			}
			else if (city.equals("New York")) {
				zipCodes = new String[] {"1000", "2000", "3000"};
				country = "United States";
			}
			else if (city.equals("Paris")) {
				zipCodes = new String[] {"12000", "12001", "12005","12010", "13001", "14005","15000", "16001", "77777"};
				country = "France";
			}
			
			//throw own error message
			if (city.equals("Nowhere")) {
				Error ownError = new UserError("myOwnError", cityType, "Nowhere Land (is that true?)", XUITypes.UIS_ENUM_CLASSIFICATION_WARNING);
				target.getDOM().getController().getErrorController().addError(ownError);
			}
			else {
				target.getDOM().getController().getErrorController().removeUserError("myOwnError", cityType);	
			}
			
			zipType.getXUIDefinition().getStyle().setEnumeration(zipCodes);
			countryType.setValue(country);
		}

	}

}
