package com.jaxfront.demo.ui.beans;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ItemEvent;
import java.beans.PropertyChangeEvent;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import com.jaxfront.core.dom.DOMChangeEvent;
import com.jaxfront.core.dom.DOMChangeListener;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.ui.TypeVisualizerFactory;
import com.jaxfront.core.ui.Visualizer;
import com.jaxfront.swing.ui.beans.AbstractComplexVisualizer;

public class SerializeXMLView extends AbstractComplexVisualizer implements DOMChangeListener {
	
	private Visualizer _wrappedVisualizer;
	private JTextArea _textArea;

	public void domChanged(DOMChangeEvent event) {
		if (event.isAddingNode() || event.isRemovingNode() 
			&& ((Type)event.getSource()).isDerivedFrom(getModel())) {
			Type parent = ((Type)event.getSource()).getParent(getModel().getName());
			if (parent != null) {
				_textArea.setText(parent.serialize().toString());
			}
			
		}
		
	}

	public void postInitialization() {
	}

	public void markError() {
	}

	public void populateModel() {
	}

	public void populateView() {
	}

	public void propertyChange(PropertyChangeEvent evt) {
		
		
		if (evt.getSource() instanceof Type) {
			Type source = (Type)evt.getSource(); 
			if ( source.isDerivedFrom(getModel())) {
				Type parent = source.getParent(getModel().getName());
				_textArea.setText(parent.serialize().toString());
			}
		}
	}

	public void release() {
	}

	public void removeLabel() {
	}

	public void resetError() {
	}

	public void setRequired(boolean aBoolean) {
		// TODO Auto-generated method stub

	}

	public void setApplicationRequired(boolean aBoolean) {
		// TODO Auto-generated method stub

	}

	public void setVisible(boolean visible) {
		// TODO Auto-generated method stub

	}


	public void itemStateChanged(ItemEvent e) {
		// TODO Auto-generated method stub

	}

	public void setEnabled(boolean enabled) {
		// TODO Auto-generated method stub

	}

	public void setChoosenKeyContextValue(
			String xpathRelativeToChoosenKeyContext, String newValue) {
		// TODO Auto-generated method stub

	}

	public void setEditable(boolean editable) {
		// TODO Auto-generated method stub

	}

	public void jumpTo() {
		// TODO Auto-generated method stub

	}

	protected void defaultBuild() {
		_wrappedVisualizer = TypeVisualizerFactory.getInstance().getVisualizer(getModel(), null, true, false);
		getModel().getDOM().getController().addPropertyChangeListener(this);
		getModel().getDOM().addDOMChangeListener(this);
		
		setLayout(new BorderLayout());
		add((JComponent)_wrappedVisualizer, BorderLayout.CENTER);
		
		_textArea = new JTextArea(null, 15, 1);
		JScrollPane scroller = new JScrollPane(_textArea);
		add(scroller, BorderLayout.NORTH);
		

	}

}
