package com.jaxfront.demo.ui.beans;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.net.URL;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import com.jaxfront.core.dom.DOMBuilder;
import com.jaxfront.core.dom.Document;
import com.jaxfront.core.type.ListType;
import com.jaxfront.core.type.Type;
import com.jaxfront.core.type.TypePathExecuter;
import com.jaxfront.core.ui.tableModel.SorterTableModel;
import com.jaxfront.core.ui.tableModel.FilterableTableModel;
import com.jaxfront.core.ui.tableModel.FlippableListTypeTableModel;
import com.jaxfront.core.ui.tableModel.ListTypeTableModel;
import com.jaxfront.core.ui.tableModel.RowLeadedListModel;
import com.jaxfront.core.util.StringTokenizer;
import com.jaxfront.core.util.TextTools;
import com.jaxfront.core.util.URLHelper;

public class TypeTableDemo {
	public static void main(String[] args) {
		URL url = URLHelper.getUserURL("examples/demo-suite/jaxfront-test-schema.xsd");
		URL xmlUrl = URLHelper.getUserURL("examples/demo-suite/jaxfront-test-schema.xml");
		URL xuiUrl = URLHelper.getUserURL("examples/demo-suite/jaxfront-test-schema.xui");
		String root = "root";
		try {
			Document dom = DOMBuilder.getInstance().build(null, url, xmlUrl, xuiUrl, root);
			int x = 150, y = 150;
			Type typeToVisualize = TypePathExecuter.getInstance().getTypeForXPath(dom.getRootType(), "/root/schema-structures/lists/namedList_inclChoiceList[list]");
			// JFrame f1 = new JFrame("standard");
			// f1.getContentPane().add(new JScrollPane(buildTable((ListType)
			// typeToVisualize)));
			// f1.setSize(x, y);
			// f1.setLocation(0,0);
			// f1.setVisible(true);
			// JFrame f2 = new JFrame("sortable");
			// f2.getContentPane().add(new
			// JScrollPane(buildSortableTable((ListType) typeToVisualize)));
			// f2.setSize(x, y);
			// f2.setLocation(x,0);
			// f2.setVisible(true);
			// JFrame f3 = new JFrame("flipable");
			// f3.getContentPane().add(buildFlipTable((ListType)
			// typeToVisualize));
			// f3.setSize(x, y);
			// f3.setLocation(x*2,0);
			// f3.setVisible(true);
			// JFrame f4 = new JFrame("flipable&sortable");
			// f4.getContentPane().add(buildSortableFlipTable((ListType)
			// typeToVisualize));
			// f4.setSize(x, y);
			// f4.setLocation(0,y);
			// f4.setVisible(true);
			// JFrame f5 = new JFrame("rowheaded");
			// f5.getContentPane().add(new
			// JScrollPane(buildRowHeadedTable((ListType) typeToVisualize)));
			// f5.setSize(x, y);
			// f5.setLocation(x,y);
			// f5.setVisible(true);
			// JFrame f6 = new JFrame("rowheaded&sortable");
			// f6.getContentPane().add(buildRowHeadedSortableTable((ListType)
			// typeToVisualize));
			// f6.setSize(x, y);
			// f6.setLocation(x*2,y);
			// f6.setVisible(true);
			// JFrame f7 = new JFrame("rowheaded&sortable&filtered");
			// f7.getContentPane().add(buildFilteredRowHeadedSortableTable((ListType)
			// typeToVisualize));
			// f7.setSize(x, y);
			// f7.setLocation(x,y*2);
			// f7.setVisible(true);
			// JFrame f8 = new JFrame("rowheaded&sortable&userfiltered");
			// f8.getContentPane().add(buildUserFilteredRowHeadedSortableTable((ListType)
			// typeToVisualize));
			// f8.setSize(x, y);
			// f8.setLocation(x*3,y);
			// f8.setVisible(true);
			JFrame f9 = new JFrame("rowheadedflipped&sortable&userfiltered");
			f9.getContentPane().add(buildUserFilteredFlipedRowHeadedSortableTable((ListType) typeToVisualize));
			f9.setSize(x, y);
			f9.setLocation(x * 4, y);
			f9.setVisible(true);
		} catch (Exception ex) {
			System.out.println("testerror");
		}
	}

	public static JComponent buildTable(ListType list) {
		ListTypeTableModel model = new ListTypeTableModel(list);
		JTable table = new JTable(model);
		return table;
	}

	public static JComponent buildRowHeadedTable(ListType list) {
		// build model
		RowLeadedListModel model = new RowLeadedListModel(new ListTypeTableModel(list));
		// create your own row label strategy based on 0
		RowLeadedListModel.RowNumberStrategy strategy = model.new RowNumberStrategy();
		strategy.setBase(0);
		// set new strategy to model
		model.setStrategy(strategy);
		// create table
		JTable table = new JTable(model);
		// set column name for row numbers
		table.getColumnModel().getColumn(0).setHeaderValue("number");
		return table;
	}

	public static JComponent buildRowHeadedSortableTable(ListType list) {
		RowLeadedListModel model = new RowLeadedListModel(new ListTypeTableModel(list));
		SorterTableModel sorterTableModel = new SorterTableModel(model);
		JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		table.getColumnModel().getColumn(0).setHeaderValue("number");
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		return scroller;
	}

	public static JComponent buildFilteredRowHeadedSortableTable(ListType list) {
		RowLeadedListModel model = new RowLeadedListModel(new ListTypeTableModel(list));
		FilterableTableModel fmodel = new FilterableTableModel(model);
		SorterTableModel sorterTableModel = new SorterTableModel(fmodel);
		fmodel.setFilteredRows(new int[] { 0, 1 });
		JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		table.getColumnModel().getColumn(0).setHeaderValue("number");
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		return scroller;
	}

	public static JComponent buildUserFilteredRowHeadedSortableTable(ListType list) {
		final JTextField txtFilter = new JTextField(4);
		final JTextField txtFilterB = new JTextField(4);
		final JTextField txtFilterRow = new JTextField(4);
		final JButton button = new JButton("add");
		final JButton copybutton = new JButton("copy");
		final ListType finalList = list;
		JPanel panel = new JPanel(new BorderLayout());
		RowLeadedListModel model = new RowLeadedListModel(new ListTypeTableModel(list));
		final FilterableTableModel fmodel = new FilterableTableModel(model);
		fmodel.setFilterColumns(new int[] { 1, 2 });
		final SorterTableModel sorterTableModel = new SorterTableModel(fmodel);
		final JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		table.getColumnModel().getColumn(0).setHeaderValue("number");
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		panel.add(scroller, BorderLayout.CENTER);
		txtFilter.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				fmodel.setFilter(new String[] { TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilter.getText()),
						TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilterB.getText()) });
				table.updateUI();
			}
		});
		txtFilterB.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				fmodel.setFilter(new String[] { TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilter.getText()),
						TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilterB.getText()) });
				table.updateUI();
			}
		});
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				finalList.addNewChild();
			}
		});
		copybutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.out.println(table.getSelectionModel().getLeadSelectionIndex());
				int selected = table.getSelectionModel().getLeadSelectionIndex();
				int modelIndex = sorterTableModel.getViewToModel(selected);
				System.out.println(finalList.getDirectChildren().get(modelIndex));
				Type selectedt = (Type) finalList.getDirectChildren().get(modelIndex);
				if (selectedt != null) {
					finalList.add(selectedt);
				}
			}
		});
		txtFilterRow.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				if (txtFilterRow.getText() != null && !txtFilterRow.getText().equals("")) {
					String[] values = TextTools.tokenize(txtFilterRow.getText(), ",");
					int[] rowsToRemove = new int[values.length];
					for (int i = 0; i < values.length; i++) {
						try {
							rowsToRemove[i] = Integer.parseInt(values[i]);
						} catch (Exception pe) {
							rowsToRemove[i] = -1;
						}
					}
					fmodel.setFilteredRows(rowsToRemove);
				} else {
					fmodel.setFilteredRows(new int[] {});
				}
				table.updateUI();
			}
		});
		JPanel buttonPanle = new JPanel();
		buttonPanle.add(txtFilter);
		buttonPanle.add(txtFilterB);
		buttonPanle.add(txtFilterRow);
		buttonPanle.add(button);
		buttonPanle.add(copybutton);
		panel.add(buttonPanle, BorderLayout.NORTH);
		return panel;
	}

	public static JComponent buildUserFilteredFlipedRowHeadedSortableTable(ListType list) {
		final JTextField txtFilter = new JTextField(4);
		final JTextField txtFilterB = new JTextField(4);
		final JTextField txtFilterRow = new JTextField(4);
		final JButton button = new JButton("add");
		final JButton copybutton = new JButton("copy");
		final ListType finalList = list;
		JPanel panel = new JPanel(new BorderLayout());
		final FlippableListTypeTableModel flip = new FlippableListTypeTableModel(list);
		RowLeadedListModel model = new RowLeadedListModel(flip);
		final FilterableTableModel fmodel = new FilterableTableModel(model);
		fmodel.setFilterColumns(new int[] { 1, 2 });
		final SorterTableModel sorterTableModel = new SorterTableModel(fmodel);
		final JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		table.getColumnModel().getColumn(0).setHeaderValue("number");
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		panel.add(scroller, BorderLayout.CENTER);
		table.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				int selected = table.getSelectionModel().getLeadSelectionIndex();
				// int modelIndex =sorterTableModel.getRealRowIndex(selected);
				// System.out.println("selected:"+selected+"
				// model:"+modelIndex);
				// System.out.println(finalList.serialize());
			}
		});
		scroller.setCorner(JScrollPane.UPPER_RIGHT_CORNER, new JButton(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				flip.setFlipped(!flip.isFlipped());
			}
		}));
		txtFilter.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				fmodel.setFilter(new String[] { TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilter.getText()),
						TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilterB.getText()) });
				table.updateUI();
			}
		});
		txtFilterB.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				fmodel.setFilter(new String[] { TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilter.getText()),
						TextTools.replace(fmodel.DEFAULT_FILTER, "#", txtFilterB.getText()) });
				table.updateUI();
			}
		});
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// TODO Auto-generated method stub
				finalList.addNewChild();
			}
		});
		copybutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// System.out.println(table.getSelectionModel().getLeadSelectionIndex());
				int selected = table.getSelectionModel().getLeadSelectionIndex();
				int modelIndex = sorterTableModel.getViewToModel(selected);
				if (modelIndex >= 0) {
					Type selectedt = (Type) finalList.getDirectChildren().get(modelIndex);
					if (selectedt != null) {
						System.out.println(selectedt.serialize());
						finalList.addNewChild(selectedt);
					}
				}
			}
		});
		txtFilterRow.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				if (txtFilterRow.getText() != null && !txtFilterRow.getText().equals("")) {
					String[] values = TextTools.tokenize(txtFilterRow.getText(), ",");
					int[] rowsToRemove = new int[values.length];
					for (int i = 0; i < values.length; i++) {
						try {
							rowsToRemove[i] = Integer.parseInt(values[i]);
						} catch (Exception pe) {
							rowsToRemove[i] = -1;
						}
					}
					fmodel.setFilteredRows(rowsToRemove);
				} else {
					fmodel.setFilteredRows(new int[] {});
				}
				table.updateUI();
			}
		});
		JPanel buttonPanle = new JPanel();
		buttonPanle.add(txtFilter);
		buttonPanle.add(txtFilterB);
		buttonPanle.add(txtFilterRow);
		buttonPanle.add(button);
		buttonPanle.add(copybutton);
		panel.add(buttonPanle, BorderLayout.NORTH);
		return panel;
	}

	public static JComponent buildSortableTable(ListType list) {
		ListTypeTableModel model = new ListTypeTableModel(list);
		SorterTableModel sorterTableModel = new SorterTableModel(model);
		JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		return table;
	}

	public static JComponent buildFlipTable(ListType list) {
		final FlippableListTypeTableModel model = new FlippableListTypeTableModel(list);
		JTable table = new JTable(model);
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroller.setCorner(JScrollPane.UPPER_RIGHT_CORNER, new JButton(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				model.setFlipped(!model.isFlipped());
			}
		}));
		return scroller;
	}

	public static JComponent buildSortableFlipTable(ListType list) {
		final FlippableListTypeTableModel model = new FlippableListTypeTableModel(list);
		SorterTableModel sorterTableModel = new SorterTableModel(model);
		JTable table = new JTable(sorterTableModel);
		sorterTableModel.setTableHeader(table.getTableHeader());
		sorterTableModel.setColumnComparator(Object.class, SorterTableModel.LEXICAL_COMPARATOR);
		JScrollPane scroller = new JScrollPane(table, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroller.setCorner(JScrollPane.UPPER_RIGHT_CORNER, new JButton(new AbstractAction() {
			public void actionPerformed(ActionEvent e) {
				model.setFlipped(!model.isFlipped());
			}
		}));
		return scroller;
	}
	// DefaultTableModel model = new MyDefaultTableModel();
	// JTable table = new JTable(model);
	// table.setModel(model);
	//    
	// // Create 3 columns
	// model.addColumn("Col1");
	// model.addColumn("Col2");
	// model.addColumn("Col3");
	// model.addRow(new Object[]{"v1"});
	//    
	// // Remove the first visible column without removing the underlying data
	// table.removeColumn(table.getColumnModel().getColumn(0));
	//    
	// // Disable autoCreateColumnsFromModel to prevent
	// // the reappearance of columns that have been removed but
	// // whose data is still in the table model
	// table.setAutoCreateColumnsFromModel(false);
	//    
	// // Remove the first visible column and its data
	// removeColumnAndData(table, 0);
	//    
	// // Remove the last visible column and its data
	// removeColumnAndData(table, table.getColumnCount()-1);
	//    
	// // Removes the specified column from the table and the associated
	// // call data from the table model.
	// public void removeColumnAndData(JTable table, int vColIndex) {
	// MyDefaultTableModel model = (MyDefaultTableModel)table.getModel();
	// TableColumn col = table.getColumnModel().getColumn(vColIndex);
	// int columnModelIndex = col.getModelIndex();
	// Vector data = model.getDataVector();
	// Vector colIds = model.getColumnIdentifiers();
	//    
	// // Remove the column from the table
	// table.removeColumn(col);
	//    
	// // Remove the column header from the table model
	// colIds.removeElementAt(columnModelIndex);
	//    
	// // Remove the column data
	// for (int r=0; r<data.size(); r++) {
	// Vector row = (Vector)data.get(r);
	// row.removeElementAt(columnModelIndex);
	// }
	// model.setDataVector(data, colIds);
	//    
	// // Correct the model indices in the TableColumn objects
	// // by decrementing those indices that follow the deleted column
	// Enumeration enum = table.getColumnModel().getColumns();
	// for (; enum.hasMoreElements(); ) {
	// TableColumn c = (TableColumn)enum.nextElement();
	// if (c.getModelIndex() >= columnModelIndex) {
	// c.setModelIndex(c.getModelIndex()-1);
	// }
	// }
	// model.fireTableStructureChanged();
	// }
	//    
	// // This subclass adds a method to retrieve the columnIdentifiers
	// // which is needed to implement the removal of
	// // column data from the table model
	// class MyDefaultTableModel extends DefaultTableModel {
	// public Vector getColumnIdentifiers() {
	// return columnIdentifiers;
	// }
	// }
	//
}
